routes/web.php
    ->middleware('can:administration')->group(function () {
        Route::resource('/recipes', 'RecipesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/posts', 'ProductsController',
            [
                'except' => []
            ]);
    });;
//
//Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
//    ->middleware('can:administration')->group(function (){
//        Route::get('/types/{type:slug}', 'TypesController@show');
//    });

Route::namespace('Recipes')->prefix('recipes')->name('recipes.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/types', 'TypesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::get('/recipes/{recipe:slug|id}', 'DraftRecipesController@show');
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/recipes', 'DraftRecipesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/types', 'DraftsTypesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/posts', 'DraftProductsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/users', 'UsersController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/password', 'PasswordController',
            [
                'except' => []
            ]);
    });

Route::namespace('Users')->prefix('users')->name('users.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/profile', 'ProfilesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Home')->prefix('home')->name('home.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/home', 'HomeController',
            [
                'except' => []
            ]);
    });

//Route::namespace('Home')->prefix('home')->name('home.')
//    ->middleware('can:administration')->group(function (){
//    Route::resource('/contacts', 'ContactUsController',
//        [
//            'except' => []
//        ]);
//});

Route::namespace('Images')->prefix('images')->name('images.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/images', 'ImagesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Ratings')->prefix('ratings')->name('ratings.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/ratings', 'RatingsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Ratings')->prefix('ratings')->name('ratings.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/values', 'RatingValuesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Comments')->prefix('comments')->name('comments.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/comments', 'CommentsController',
            [
                'except' => []
            ]);
    });

Route::namespace('Comments')->prefix('comments')->name('comments.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/values', 'RatingCommentsValuesController',
            [
                'except' => []
            ]);
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::get('/books/create', 'BooksController@create');
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::get('/books/{books:slug}', 'BooksController@show');
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/books', 'BooksController',
            [
                'except' => []
            ]);
    });

Route::namespace('Books')->prefix('books')->name('books.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/buy', 'BuyFromController',
            [
                'except' => []
            ]);
    });

Route::namespace('Subscribers')->prefix('subscribers')->name('subscribers.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/subscribers', 'SubscribersController',
            [
                'except' => []
            ]);
    });


/*
 * Publish routes
 */


Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/publish', 'PublishController',
            [
                'except' => ['index', 'show', 'edit', 'destroy', 'create', 'store']
            ]);
    });

Route::namespace('Drafts')->prefix('drafts')->name('drafts.')
    ->middleware('can:administration')->group(function () {
        Route::resource('/preparing', 'PreparingController',
            [
                'except' => ['index', 'show', 'edit', 'destroy', 'create', 'store']
            ]);
    });


Route::group(['middleware' => ['can:administration', 'archive']], function () {

        Route::get('/analyst/archive', 'Administrator\AnalystController@archive')
            ->name('analyst.archive');
        Route::get('/analyst/archive/sort/{value}/{where}', 'Administrator\AnalystController@archiveSort')
            ->name('analyst.archive.sort');
        Route::get('/analyst/archive/delete', 'Administrator\AnalystController@archiveDelete')
            ->name('analyst.archive.delete');

        Route::patch('/analyst/archive/chosen', 'Administrator\AnalystController@archiveChosen')
            ->name('analyst.archive.delete-chosen');


        Route::get('/analyst', 'Administrator\AnalystController@index')
            ->name('analyst.index');
        Route::get('/analyst/sort/{value}/{where}', 'Administrator\AnalystController@sort')
            ->name('analyst.sort');
        Route::get('/analyst/look/{value}/{look}', 'Administrator\AnalystController@look')
            ->name('analyst.look');
        Route::get('/analyst/by-date/{key}', 'Administrator\AnalystController@byDate')
            ->name('analyst.by-date');

        Route::get('/analyst/custom-analyst', 'Administrator\AnalystController@custom')
            ->name('analyst.custom-analyst');
        Route::get('/analyst/custom-analyst/sort/{analystCustom}/{value}/{where}', 'Administrator\AnalystController@customSort')
            ->name('analyst.custom-analyst.sort');
        Route::post('/analyst/custom-analyst', 'Administrator\AnalystController@customStore')
            ->name('analyst.custom-analyst.store');
        Route::get('/analyst/custom-analyst/{analystCustom}', 'Administrator\AnalystController@customShow')
            ->name('analyst.custom-analyst.show');
        Route::delete('/analyst/custom-analyst/{analystCustom}', 'Administrator\AnalystController@customDelete')
            ->name('analyst.custom-analyst.delete');

        Route::get('/analyst/in-progress', 'Administrator\AnalystController@inProgress')
            ->name('analyst.in-progress');

        //counters

        Route::get('/counter/index/{key}', 'Administrator\CountsController@index')
            ->name('counter.index');
        Route::get('/counter/by/{countType}/{key}', 'Administrator\CountsController@by')
            ->name('counter.by');
        Route::get('/counter/custom', 'Administrator\CountsController@custom')
            ->name('counter.custom');
        Route::post('/counter/custom', 'Administrator\CountsController@customStore')
            ->name('counter.custom.store');
        Route::get('/counter/custom/{countableCustom}', 'Administrator\CountsController@customShow')
        ->name('counter.custom.show');
        Route::delete('/counter/custom/{countableCustom}', 'Administrator\CountsController@customDelete')
            ->name('counter.custom.delete');




        Route::get('/counter/admin/{pass}', 'Administrator\CountsController@admin')
            ->name('counter.admin');
        Route::get('/counter/change/{pass}', 'Administrator\CountsController@adminChangeDraftToRecipes')
            ->name('counter.change');



    /*
     * partners
     */

    Route::get('/partners', 'Partners\PartnersController@index')
        ->name('partners');
    Route::post('/partners', 'Partners\PartnersController@store')
        ->name('partners-post');
    Route::get('/partners/{partner}', 'Partners\PartnersController@show')
        ->name('partners-show');
    Route::delete('/partners/{partner}', 'Partners\PartnersController@destroy')
        ->name('partners-destroy');
    Route::patch('/partners/{partner}', 'Partners\PartnersController@update')
        ->name('partners-update');

    /*
     * contact us controller
     */

    Route::get('/contacts/{messageType}', 'Home\ContactUsController@index')
        ->name('contacts');

app/Models/Rating.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Model;

class Rating extends Model
{
    protected $guarded = [];

    public function recipes()
    {
        return $this->belongsToMany('App\Models\Recipe', 'recipes_ratings', 'rating_id', 'recip_id');
    }

    public function ratingValues()
    {
        return $this->hasMany('App\Models\RatingValue');
    }

    public function ratingRecipes()
    {
        return $this->hasMany('App\Models\RatingRecipe');
    }
}

app/Http/Controllers/Ratings/RatingValuesController.php
<?php

namespace App\Http\Controllers\Ratings;

use App\Http\Controllers\Controller;
use App\Models\RatingValue;
use App\Models\Recipe;
use App\Repositories\RecipesRepositoryInterface;
use App\Repositories\TrafficRepositoryInterface;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Cookie;

class RatingValuesController extends Controller
{

    /**
     * @var TrafficRepositoryInterface
     */
    private $trafficRepository;
    /**
     * @var RecipesRepositoryInterface
     */
    private $recipesRepository;

    public function __construct(TrafficRepositoryInterface $trafficRepository,
                                RecipesRepositoryInterface $recipesRepository)
    {
        $this->trafficRepository = $trafficRepository;
        $this->recipesRepository = $recipesRepository;
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);

        return redirect('recipes.recipes.index');
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action = 'create';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $action = 'store';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\RatingValue  $ratingValue
     * @return \Illuminate\Http\Response
     */
    public function show(RatingValue $ratingValue)
    {
        $action = 'show';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\RatingValue  $ratingValue
     * @return \Illuminate\Http\Response
     */
    public function edit(RatingValue $ratingValue)
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Recipe  $value
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Recipe $value)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);


        $cookies = Cookie::get();
        if(empty($cookies['laravel_cookie_consent'])){
            return redirect()->route('recipes.recipes.show', $value->slug);
        } else {
            Cookie::queue('2', '2', '2');
        }

        $attach = $this->recipesRepository->setRating($request, $value);

        return redirect()->route('recipes.recipes.show', $value->slug);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\RatingValue  $ratingValue
     * @return \Illuminate\Http\Response
     */
    public function destroy(RatingValue $ratingValue)
    {
        $action = 'destroy';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }
}

app/Http/Controllers/Ratings/RatingsController.php
<?php

namespace App\Http\Controllers\Ratings;

use App\Http\Controllers\Controller;
use App\Models\Rating;
use App\Repositories\RatingsRepositoryInterface;
use App\Repositories\TrafficRepositoryInterface;
use Illuminate\Http\Request;

class RatingsController extends Controller
{

    /**
     * @var TrafficRepositoryInterface
     */
    private $trafficRepository;
    /**
     * @var RatingsRepositoryInterface
     */
    private $ratingsRepository;

    public function __construct(TrafficRepositoryInterface $trafficRepository,
                                RatingsRepositoryInterface $ratingsRepository)
    {
        $this->trafficRepository = $trafficRepository;
        $this->ratingsRepository = $ratingsRepository;
    }
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $action = 'index';
        $this->trafficRepository->getRemoteAddress($action);

        $ratings = $this->ratingsRepository->getAllRatings();

        return view('ratings.ratings.index')->with('ratings', $ratings);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $action = 'create';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $action = 'store';
        $this->trafficRepository->getRemoteAddress($action);

        $this->ratingsRepository->addNewRating($request);

        return $this->index();
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Rating  $rating
     * @return \Illuminate\Http\Response
     */
    public function show(Rating $rating)
    {
        $action = 'show';
        $this->trafficRepository->getRemoteAddress($action);

        return $this->index();
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Rating  $rating
     * @return \Illuminate\Http\Response
     */
    public function edit(Rating $rating)
    {
        $action = 'edit';
        $this->trafficRepository->getRemoteAddress($action);

        return view('ratings.ratings.edit')->with('rating', $rating);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Rating  $rating
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Rating $rating)
    {
        $action = 'update';
        $this->trafficRepository->getRemoteAddress($action);

        $this->ratingsRepository->updateRating($request, $rating);

        return $this->index();
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Rating  $rating
     * @return \Illuminate\Http\Response
     */
    public function destroy(Rating $rating)
    {
        $action = 'destroy';
        $this->trafficRepository->getRemoteAddress($action);

        $this->ratingsRepository->deleteRating($rating);

        return $this->index();
    }
}

resources/views/ratings/ratings/edit.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="container">
                    <div class="row">
                        <div class="col-md-6 m-auto">
                            <div class="well">
                                <h5 class="text-center">
                                    <label>
                                        Промени рейтинг: {{ $rating->name }}
                                    </label>
                                </h5>
                                <form action="{{ route('ratings.ratings.update', $rating->id) }}" method="POST">
                                    @csrf
                                    @method('PATCH')
                                    <div class="card">
                                        <div class="card-header">
                                            <label for="name">
                                                Name:
                                            </label>
                                        </div>
                                        <div class="card-body">
                                            <h5>
                                                <input id="name"
                                                       type="text"
                                                       class="form-control @error('name') is-invalid @enderror"
                                                       name="name"
                                                       value=@if(old('name'))"{{old('name')}}"@else"{{$rating->name}}"@endif
                                                       required autocomplete="name" autofocus>
                                                @error('name')
                                                <br>
                                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                                @enderror
                                            </h5>
                                        </div>
                                    </div>
                                    <div class="card">
                                        <div class="card-header">
                                            <label for="value">
                                                Стойност:
                                            </label>
                                        </div>
                                        <div class="card-body">
                                            <h5>
                                                <input id="value"
                                                       type="text"
                                                       class="form-control @error('value') is-invalid @enderror"
                                                       name="value"
                                                       value=@if(old('value'))"{{old('value')}}"@else"{{implode(',', $rating->ratingValues()->pluck('value')->toArray())}}"@endif
                                                       required autocomplete="value" autofocus>
                                                @error('value')
                                                <br>
                                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                                @enderror
                                            </h5>
                                        </div>
                                    </div>
                                    <div class="d-flex justify-content-center m-2">
                                        <button type="submit" class="btn btn-dark">
                                            Промени
                                        </button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection

resources/views/ratings/ratings/index.blade.php
@extends('layouts.app')

@section('content')
    <div class="container">
        <div class="row">
            <div class="col-md-12">
                <div class="container">
                    <div class="row">
                        <div class="col-md-8">
                            <div class="card my-3 mx-auto">
                                <div class="card-header">
                                    <h4>
                                        Рейтинги:
                                    </h4>
                                </div>
                                <div class="card-body">
                                    <table class="table table-borderless">
                                        <thead>
                                            <tr>
                                                <th>#</th>
                                                <th>Name</th>
                                                <th>Value</th>
                                                <th>Actions</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                        @foreach($ratings as $rating)
                                            <tr>
                                                <td>
                                                    {{$rating->id}}
                                                </td>
                                                <td>
                                                    {{$rating->name}}
                                                </td>
                                                <td>
                                                    {{implode(',', $rating->ratingValues()->pluck('value')->toArray())}}
                                                </td>
                                                <td>
                                                    <a href="{{route('ratings.ratings.edit', $rating->id)}}"><button type="button" class="btn btn-dark float-left">Промени</button></a>
                                                    <form action="{{ route('ratings.ratings.destroy', $rating->id) }}" method="POST">
                                                        @csrf
                                                        @method('DELETE')
                                                        <button type="submit" class="btn btn-danger float-left" onclick="alert('Сигурни ли сте?')">Изтрий</button>
                                                    </form>
                                                </td>
                                            </tr>
                                        @endforeach
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                        <div class="col-md-4 my-3">
                            <div class="well">
                                <h4 class="text-center">
                                    <label>
                                        Добави рейтинг
                                    </label>
                                </h4>
                                <form action="{{ route('ratings.ratings.store') }}" method="POST">
                                    @csrf
                                    <div class="card">
                                        <div class="card-header">
                                            <label for="name">
                                                Name:
                                            </label>
                                        </div>
                                        <div class="card-body">
                                            <h5>
                                                <input id="name"
                                                       type="text"
                                                       class="form-control @error('name') is-invalid @enderror"
                                                       name="name"
                                                       value="{{ old('name') }}"
                                                       required autocomplete="name" autofocus>
                                                @error('name')
                                                <br>
                                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                                @enderror
                                            </h5>
                                        </div>
                                    </div>
                                    <div class="card">
                                        <div class="card-header">
                                            <label for="value">
                                                Стойност:
                                            </label>
                                        </div>
                                        <div class="card-body">
                                            <h5>
                                                <input id="value"
                                                       type="text"
                                                       class="form-control @error('value') is-invalid @enderror"
                                                       name="value"
                                                       value="{{ old('value') }}"
                                                       required autocomplete="value" autofocus>
                                                @error('value')
                                                <br>
                                                <span class="invalid-feedback" role="alert">
                                        <strong>{{ $message }}</strong>
                                    </span>
                                                @enderror
                                            </h5>
                                        </div>
                                    </div>
                                    <div class="d-flex justify-content-center m-2">
                                        <button type="submit" class="btn btn-dark">
                                            Добави
                                        </button>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
@endsection